//+------------------------------------------------------------------+
//|                                     Brooky_Boll_PocketV1.1.1.mq4 |
//|                                          Copyright  2010,Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DarkOrange
#property indicator_color2 SteelBlue
#property indicator_color3 Red
#property indicator_color4 DarkOrange 
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2 
 
//---- input parameters
extern int       Boll1_Period=57;
extern int       Boll2_Period=27;
extern int       Dev=2;
extern int       Candle_W=4;
extern int       LineStyle = 2;
extern int       LineStyle2 = 1;
extern int       LineStyle3 = 0;
extern bool      showMean = true;
extern bool      shadeHiLo = false;
extern bool      seeMeanCross = true;
extern int       MeanCrossArrow = 171;


//---- buffers

double Boll1Upper[];
double Boll1Lower[];
double Boll2Upper[];
double Boll2Lower[];
double BollAvMean[];
double CandleLong[];
double CandleShort[];
double CandleFlat[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   
   SetIndexBuffer(0,CandleLong);SetIndexStyle(0,DRAW_HISTOGRAM,4,Candle_W);
   SetIndexBuffer(1,CandleShort);SetIndexStyle(1,DRAW_HISTOGRAM,4,Candle_W);      
   SetIndexBuffer(2,CandleFlat);
         SetIndexStyle(2,DRAW_ARROW);
             SetIndexArrow(2,MeanCrossArrow);
                SetIndexEmptyValue(2,0.0);   
   SetIndexBuffer(3,BollAvMean);SetIndexStyle(3,DRAW_LINE,LineStyle3);   
   
   SetIndexBuffer(4,Boll1Upper);
   
   SetIndexBuffer(5,Boll1Lower);
   
   SetIndexBuffer(6,Boll2Upper);
   
   SetIndexBuffer(7,Boll2Lower);
   



   

   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
     //int Cpos=Bars-counted_bars-1;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
       //---Upper Bands---+
        Boll1Upper[i]=iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_UPPER,i);
        Boll2Upper[i]=iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_UPPER,i);
        //---Lower Bands---+
        Boll1Lower[i]=iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_LOWER,i);
        Boll2Lower[i]=iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_LOWER,i);
        //---Av Mean Bands---+
        if(showMean !=false)
        BollAvMean[i]=((iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_MAIN,i))+(iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_MAIN,i)))/2;
        double BollMean =((iBands(NULL,0,Boll1_Period,Dev,0,PRICE_MEDIAN,MODE_MAIN,i))+(iBands(NULL,0,Boll2_Period,Dev,0,PRICE_MEDIAN,MODE_MAIN,i)))/2;
        //---Candle Coloring---+
        
        double shortit=0,longit=0,flatit=0;
        //---Short Possibilities---+
        if(iClose(NULL,0,i)>Boll1Upper[i] && iClose(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iOpen(NULL,0,i)>Boll1Upper[i] && iOpen(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iLow(NULL,0,i)>Boll1Upper[i] && iLow(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iHigh(NULL,0,i)>Boll1Upper[i] && iHigh(NULL,0,i)<Boll2Upper[i])shortit=2;
        if(iHigh(NULL,0,i)>Boll2Upper[i] && iLow(NULL,0,i)<Boll1Upper[i])shortit=2;
        if(iHigh(NULL,0,i)>Boll2Upper[i] && iHigh(NULL,0,i)>Boll1Upper[i])shortit=2;
        
        //---Long Possibilities---+
        if(iClose(NULL,0,i)>Boll1Lower[i] && iClose(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iOpen(NULL,0,i)>Boll1Lower[i] && iOpen(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iLow(NULL,0,i)>Boll1Lower[i] && iLow(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iHigh(NULL,0,i)>Boll1Lower[i] && iHigh(NULL,0,i)<Boll2Lower[i])longit=1;
        if(iHigh(NULL,0,i)>Boll2Lower[i] && iLow(NULL,0,i)<Boll1Lower[i])longit=1;
        if(iHigh(NULL,0,i)<Boll2Lower[i] && iHigh(NULL,0,i)<Boll1Lower[i])longit=1;
        
        //---Reversal on Mean Possibilities
        
        if(iHigh(NULL,0,i)>BollMean && iLow(NULL,0,i)<BollMean)flatit=1;
        
        //---Shade Complete Candle---+
        if (shortit==2 && shadeHiLo!=false)
        {
       CandleLong[i]=iHigh(NULL,0,i);
       CandleShort[i]=iLow(NULL,0,i);
        }
        
        if (longit==1 && shadeHiLo!=false)
       {
       CandleLong[i]=iLow(NULL,0,i);
       CandleShort[i]=iHigh(NULL,0,i);
       }
        if (flatit==1 && shadeHiLo!=false && seeMeanCross!=false)
       {
       CandleFlat[i]=iClose(NULL,0,i);
       }       
       
       //---Shade Open to Close of Candle---+
        if (shortit==2 && shadeHiLo!=true)
        {
       CandleLong[i]=iOpen(NULL,0,i);
       CandleShort[i]=iClose(NULL,0,i);
        }
        
        if (longit==1 && shadeHiLo!=true)
       {
       CandleLong[i]=iOpen(NULL,0,i);
       CandleShort[i]=iClose(NULL,0,i);
       }       
       
       if (flatit==1 && shadeHiLo!=true && seeMeanCross!=false)
       {
        CandleFlat[i]=iClose(NULL,0,i);
       }

       }
  //---- done
     return(0);
    }
//+------------------------------------------------------------------+